/*  footnote.js */
/*  This is a short sample to solve some of the issues with footnotes on GrokLaw. 
	This code is written by Maarten Sneep, and is placed in the public domain.
	
	Tested with Firefox 1.0.3, Mozilla 1.7.5, Safari 1.3. 
	Also tested on Internet Explorer 5.2.3 (mac). It fails there, but the links 
	still work. That shouldn't be a problem for the regular GrokLaw audience.
	   
	Have fun, Maarten (April 2005).
*/

var detect = navigator.userAgent.toLowerCase();
var OS,browser,version,total,thestring;

if (checkIt('konqueror'))
{
        browser = "Konqueror";
        OS = "Linux";
}
else if (checkIt('safari')) browser = "Safari"
else if (checkIt('omniweb')) browser = "OmniWeb"
else if (checkIt('opera')) browser = "Opera"
else if (checkIt('webtv')) browser = "WebTV";
else if (checkIt('icab')) browser = "iCab"
else if (checkIt('msie')) browser = "Internet Explorer"
else if (!checkIt('compatible'))
{
        browser = "Netscape Navigator"
        version = detect.charAt(8);
}
else browser = "An unknown browser";

if (!version) version = detect.charAt(place + thestring.length);

if (!OS)
{
        if (checkIt('linux')) OS = "Linux";
        else if (checkIt('x11')) OS = "Unix";
        else if (checkIt('mac')) OS = "Mac"
        else if (checkIt('win')) OS = "Windows"
        else OS = "an unknown operating system";
}

function checkIt(string)
{
        place = detect.indexOf(string) + 1;
        thestring = string;
        return place;
}

if( OS != 'Windows' && browser != 'Internet Explorer') {
/* set some properties */

var g_offsetX = 0;
var g_offsetY = 18;
var g_margins = 10;
var g_footnoteVisible = false;

function showfootnote(fn_ref){
	// This function should be called on a mouseover of the reference
	// The argument is the id of the span that contains the text of the footnote
	var fn = document.getElementById("footnote");
	var contents = document.getElementById(fn_ref);
	if (!fn) {
		return true;
	} else if(!contents) {
		return true;
	} else if( !contents.innerHTML ) {
		return true;
	} else {
		fn.innerHTML = contents.innerHTML;
		g_footnoteVisible = true;
		return false;
	}
}

function clearfootnote(){
	// hide the footnote again
	var fn = document.getElementById("footnote");
	if (g_footnoteVisible && fn) {
		g_footnoteVisible = false;
		fn.style.visibility="hidden";
		fn.style.left="-1000px";
		fn.innerHTML = "";
	}
}

function moveFootnote(event) {
	// the big one: it figures out where the room is and places the label.
	if(g_footnoteVisible) {
		var fn = document.getElementById("footnote");
		var wwidth = window.innerWidth - g_margins;
		var wheight = window.innerHeight - g_margins;
		
		if (!fn || !wwidth || !wheight ) { return; }
		
		var floatWidth = fn.offsetWidth + g_margins;
		var left = event.pageX - window.pageXOffset; 
		var right = wwidth - left - g_margins; // correct for scroll bar
		
		if ( !floatWidth || !left || !right ) { return; }
		
		if ( left < floatWidth/2 ){
			fn.style.left = (g_margins/2) + "px"
		} else if ( right < floatWidth/2 ) {
			fn.style.left = (wwidth - floatWidth) + "px"
		} else {
			fn.style.left = (event.pageX - floatWidth/2) + "px";
		}
		
		var fromBottom = wheight - event.pageY + window.pageYOffset;
		if ( fromBottom < fn.offsetHeight + g_margins ){
			fn.style.top = (event.pageY - fn.offsetHeight - g_margins) + "px";
		} else {
			fn.style.top = (event.pageY + g_offsetY) + "px";
		}
		fn.style.visibility = "visible";
	}
}

function moveFootnoteEventHandler(evt) {
	event = (evt) ? evt : ((window.event) ? window.event : false);
	if (event && g_footnoteVisible){
		moveFootnote(event);
	}
}
// set the mouse moved event handler to the code that will 
// position the footnote floating box
document.onmousemove = moveFootnoteEventHandler;
} else {
	function showfootnote(fn_ref){ return true; }
	function clearfootnote(){ return; }
}